 contrib/ctidscan/Makefile                  |   19 +
 contrib/ctidscan/ctidscan--1.0.sql         |   12 +
 contrib/ctidscan/ctidscan.c                | 1695 ++++++++++++++++++++++++++++
 contrib/ctidscan/ctidscan.control          |    5 +
 contrib/ctidscan/expected/ctidscan.out     |  294 +++++
 contrib/ctidscan/sql/ctidscan.sql          |   50 +
 src/backend/catalog/Makefile               |    2 +-
 src/backend/catalog/dependency.c           |   12 +-
 src/backend/catalog/objectaddress.c        |   60 +
 src/backend/commands/Makefile              |    2 +-
 src/backend/commands/custom_plan.c         |  335 ++++++
 src/backend/commands/dropcmds.c            |    5 +
 src/backend/commands/explain.c             |   38 +
 src/backend/executor/Makefile              |    2 +-
 src/backend/executor/execAmi.c             |   24 +
 src/backend/executor/execProcnode.c        |   19 +
 src/backend/executor/nodeCustom.c          |  100 ++
 src/backend/nodes/copyfuncs.c              |   47 +
 src/backend/nodes/equalfuncs.c             |   14 +
 src/backend/nodes/outfuncs.c               |   39 +
 src/backend/optimizer/path/allpaths.c      |   31 +-
 src/backend/optimizer/path/joinpath.c      |    7 +
 src/backend/optimizer/plan/createplan.c    |   30 +
 src/backend/optimizer/plan/setrefs.c       |   14 +-
 src/backend/optimizer/plan/subselect.c     |   21 +-
 src/backend/parser/gram.y                  |   91 +-
 src/backend/tcop/utility.c                 |   16 +
 src/backend/utils/adt/ruleutils.c          |   52 +
 src/backend/utils/cache/syscache.c         |   23 +
 src/include/catalog/dependency.h           |    1 +
 src/include/catalog/indexing.h             |    6 +
 src/include/catalog/pg_custom_plan.h       |   51 +
 src/include/catalog/pg_operator.h          |    3 +
 src/include/commands/custom_plan.h         |   59 +
 src/include/executor/nodeCustom.h          |   30 +
 src/include/nodes/execnodes.h              |   41 +
 src/include/nodes/nodes.h                  |    5 +
 src/include/nodes/parsenodes.h             |   13 +
 src/include/nodes/plannodes.h              |   51 +
 src/include/nodes/relation.h               |   32 +
 src/include/optimizer/subselect.h          |    6 +
 src/include/parser/kwlist.h                |    3 +
 src/include/utils/builtins.h               |    2 +
 src/include/utils/syscache.h               |    2 +
 src/test/regress/expected/sanity_check.out |    1 +
 45 files changed, 3327 insertions(+), 38 deletions(-)

diff --git a/contrib/ctidscan/Makefile b/contrib/ctidscan/Makefile
new file mode 100644
index 0000000..1e476a6
--- /dev/null
+++ b/contrib/ctidscan/Makefile
@@ -0,0 +1,19 @@
+# contrib/ctidscan/Makefile
+
+MODULES = ctidscan
+
+EXTENSION = ctidscan
+DATA = ctidscan--1.0.sql
+
+REGRESS = ctidscan
+
+ifdef USE_PGXS
+PG_CONFIG = pg_config
+PGXS := $(shell $(PG_CONFIG) --pgxs)
+include $(PGXS)
+else
+subdir = contrib/ctidscan
+top_builddir = ../..
+include $(top_builddir)/src/Makefile.global
+include $(top_srcdir)/contrib/contrib-global.mk
+endif
diff --git a/contrib/ctidscan/ctidscan--1.0.sql b/contrib/ctidscan/ctidscan--1.0.sql
new file mode 100644
index 0000000..5aca9b9
--- /dev/null
+++ b/contrib/ctidscan/ctidscan--1.0.sql
@@ -0,0 +1,12 @@
+--
+-- Create ctidscan handler function
+--
+CREATE FUNCTION ctidscanaddpath(internal)
+  RETURNS pg_catalog.void
+  AS 'MODULE_PATHNAME','CtidScanAddPath'
+  LANGUAGE C STRICT;
+
+--
+-- Create a custom-plan provider
+--
+CREATE CUSTOM PLAN ctidscan FOR scan HANDLER ctidscanaddpath;
